<template>
  <a-card :bordered="false">
    <!-- 查询区域 -->
    <div class="table-page-search-wrapper">
      <a-form layout="inline" @keyup.enter.native="searchQuery">
        <a-row :gutter="24">
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <a-form-item label="散货柜编号">
              <a-input placeholder="请输入散货柜编号" v-model="queryParam.bulkNo"></a-input>
            </a-form-item>
          </a-col>
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <a-form-item label="货柜号">
              <a-input placeholder="请输入货柜号" v-model="queryParam.containerNo"></a-input>
            </a-form-item>
          </a-col>
          <template v-if="toggleSearchStatus">
            <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <a-form-item label="仓库名称">
              <j-search-select-tag placeholder="请选择仓库名称" v-model="queryParam.warehouseName" dict="iost_storage,name,id"/>
            </a-form-item>
          </a-col>
          </template>
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <span style="float: left;overflow: hidden;" class="table-page-search-submitButtons">
              <a-button type="primary" @click="searchQuery" icon="search">查询</a-button>
              <a-button type="primary" @click="searchReset" icon="reload" style="margin-left: 8px">重置</a-button>
              <a @click="handleToggleSearch" style="margin-left: 8px">
                {{ toggleSearchStatus ? '收起' : '展开' }}
                <a-icon :type="toggleSearchStatus ? 'up' : 'down'"/>
              </a>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <!-- 查询区域-END -->

    <!-- 操作按钮区域 -->
    <div class="table-operator">
      <a-button type="primary" icon="download" @click="handleExportXls('送货管理')">导出</a-button>
    </div>

    <!-- table区域-begin -->
    <div>
      <div class="ant-alert ant-alert-info" style="margin-bottom: 16px;">
        <i class="anticon anticon-info-circle ant-alert-icon"></i> 已选择 <a style="font-weight: 600">{{ selectedRowKeys.length }}</a>项
        <a style="margin-left: 24px" @click="onClearSelected">清空</a>
      </div>

      <a-table
        ref="table"
        size="middle"
        :scroll="{x:true}"
        bordered
        rowKey="id"
        :columns="columns"
        :dataSource="dataSource"
        :pagination="ipagination"
        :loading="loading"
        :rowSelection="{selectedRowKeys: selectedRowKeys, onChange: onSelectChange}"
        class="j-table-force-nowrap"
        @change="handleTableChange">

        <template slot="htmlSlot" slot-scope="text">
          <div v-html="text"></div>
        </template>
        <template slot="imgSlot" slot-scope="text">
          <span v-if="!text" style="font-size: 12px;font-style: italic;">无图片</span>
          <img v-else :src="getImgView(text)" height="25px" alt="" style="max-width:80px;font-size: 12px;font-style: italic;"/>
        </template>
        <template slot="fileSlot" slot-scope="text">
          <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
          <a-button
            v-else
            :ghost="true"
            type="primary"
            icon="download"
            size="small"
            @click="downloadFile(text)">
            下载
          </a-button>
        </template>

        <span slot="action" slot-scope="text, record">
          <a @click="editStatus(record)">更新物流状态</a>
          <a-divider type="vertical" />
          <a @click="genSummaryBill(record)">生成汇总单</a>
          <a-divider type="vertical" />
          <a @click="handleEdit(record)">查看保险单</a>
          <a-divider type="vertical" />
          <a @click="exportDeliveryNotePdf(record)">查看送货单</a>
          <a-divider type="vertical" />
          <a @click="exportDeliveryNotePicPdf(record)">查看送货单图片</a>
          <a-divider type="vertical" />
          <a @click="exportReceivingNotePdf(record)">查看收费单</a>
          <a-divider type="vertical" />
          <a @click="handlePrint(record)">打印全部送货单</a>
          <a-divider type="vertical" />
        </span>


      </a-table>
    </div>

    <!-- <iost-deliverstatus-modal ref="statusModalForm" @ok="modalFormOk"/> -->
    <!-- <iost-delivery-management-modal ref="modalForm" @ok="modalFormOk"></iost-delivery-management-modal> -->
    <iost-delivery-management-p-modal ref="modalForm" @ok="modalFormOk"/>
  </a-card>
</template>

<script>

  import '@/assets/less/TableExpand.less'
  import { mixinDevice } from '@/utils/mixin'
  import { JeecgListMixin } from '@/mixins/JeecgListMixin'
  import IostDeliveryManagementModal from './modules/IostDeliveryManagementModal'
  import IostDeliverstatusModal from './modules/IostDeliverstatusModal'
  import IostDeliveryManagementPModal from './modules/IostDeliveryManagementPModal'
  import { getAction, downFile } from '@/api/manage'
  import JSearchSelectTag from '@/components/dict/JSearchSelectTag'

  export default {
    name: 'IostDeliveryManagementList',
    mixins:[JeecgListMixin, mixinDevice],
    components: {
      IostDeliveryManagementModal,
      IostDeliverstatusModal,
      JSearchSelectTag,
      IostDeliveryManagementPModal
    },
    data () {
      return {
        description: '送货管理管理页面',
        // 表头
        columns: [
          {
            title: '#',
            dataIndex: '',
            key:'rowIndex',
            width:60,
            align:"center",
            customRender:function (t,r,index) {
              return parseInt(index)+1;
            }
          },
          {
            title:'散货柜编号',
            align:"center",
            dataIndex: 'bulkNo'
          },
          {
            title:'仓库名称',
            align:"center",
            dataIndex: 'warehouseName_dictText'
          },
          {
            title:'货柜号',
            align:"center",
            dataIndex: 'containerNo'
          },
          {
            title:'总体积',
            align:"center",
            dataIndex: 'volumeTotals'
          },
          {
            title:'总装箱数',
            align:"center",
            dataIndex: 'packagesTotals'
          },
          {
            title:'总重量',
            align:"center",
            dataIndex: 'weightTotals'
          },
          {
            title:'总金额',
            align:"center",
            dataIndex: 'moneyTotal'
          },
          {
            title:'装柜日期',
            align:"center",
            dataIndex: 'loadingDate',
            customRender:function (text) {
              return !text?"":(text.length>10?text.substr(0,10):text)
            }
          },
          {
            title: '操作',
            dataIndex: 'action',
            align:"center",
            fixed:"right",
            width:147,
            scopedSlots: { customRender: 'action' }
          }
        ],
        url: {
          list: "/basedata/iostDeliveryRecord/list",
          exportXlsUrl: "/basedata/iostDeliveryRecord/exportXls",          
        },
        dictOptions:{},
      }
    },
    created() {
    },
    computed: {
      importExcelUrl: function(){
        return `${window._CONFIG['domianURL']}/${this.url.importExcelUrl}`;
      },
    },
    methods: {
      editStatus(record){
        this.$refs.statusModalForm.edit(record);
      },
      genSummaryBill(record){
          let that = this;
          this.$confirm({
            title: "确认生成",
            content: "是否根据选中数据生成汇总单?",
            onOk: function () {
                let url = `${window._CONFIG['domianURL']}/basedata/iostSummarySheet/addFromDeliveryManagement`;
                getAction(url, {id:record.id}).then((res) => {
                if (res.success) {
                  that.$message.success(res.result);
                }
                else
                {
                  that.$message.warning(res.message)
                }
                that.loading = false;
              })
            }
        });
      },
      exportReceivingNotePdf(record){
        let url = `${window._CONFIG['domianURL']}/basedata/iostReceivingNote/exportReceivingNotePdf`;
        downFile(url, {deliveryRecordId:record.id}).then((data) =>
        {        
          if (!data) {
            this.$message.warning("文件下载失败")
            return
          }        
          //type类型可以设置为文本类型，这里是pdf类型
          this.pdfUrl = window.URL.createObjectURL(new Blob([data], { type: `application/pdf` }));
          const fname = record.bulkNo + `_收费单`; // 下载文件的名字
          const link = document.createElement('a');
          link.href = this.pdfUrl;
          link.setAttribute('download', fname);
          document.body.appendChild(link);
          link.click();
        });
      },
      exportDeliveryNotePdf(record){
        console.log(record.id)
        let url = `${window._CONFIG['domianURL']}/basedata/iostDeliveryNote/exportDeliveryNotePdf`;
        downFile(url, {deliveryRecordId:record.id}).then((data) =>
        {        
          if (!data) {
            this.$message.warning("文件下载失败")
            return
          }        
          //type类型可以设置为文本类型，这里是pdf类型
          this.pdfUrl = window.URL.createObjectURL(new Blob([data], { type: `application/pdf` }));
          const fname = record.bulkNo + `_送货单`; // 下载文件的名字
          const link = document.createElement('a');
          link.href = this.pdfUrl;
          link.setAttribute('download', fname);
          document.body.appendChild(link);
          link.click();
        });
      },      
      exportDeliveryNotePicPdf(record){
        let url = `${window._CONFIG['domianURL']}/basedata/iostDeliveryNote/exportDeliveryNotePicPdf`;
        downFile(url, {deliveryRecordId:record.id}).then((data) =>
        {
          console.log(record)
          console.log("data")
          console.log(data)
          if (!data) {
            this.$message.warning("文件下载失败")
            return
          }        
          //type类型可以设置为文本类型，这里是pdf类型
          this.pdfUrl = window.URL.createObjectURL(new Blob([data], { type: `application/pdf` }));
          const fname = record.bulkNo + `_送货单`; // 下载文件的名字
          const link = document.createElement('a');
          link.href = this.pdfUrl;
          link.setAttribute('download', fname);
          document.body.appendChild(link);
          link.click();
        });
      },
      handleCopy(record)
      {
        this.$refs.copyModalForm.edit(record);
        this.$refs.copyModalForm.title = "打印收费单";
        this.$refs.copyModalForm.disableSubmit = true;
      },
      handlePrint(record)
      {
        this.$refs.modalForm.edit(record);
        this.$refs.modalForm.title = "打印全部送货单";
        this.$refs.modalForm.disableSubmit = true;
      },
      initDictConfig(){
      }
    }
  }
</script>
<style scoped>
  @import '~@assets/less/common.less';
</style>